/***********************************************************************
	Module FINDTSR.C
	Search for loaded TSR in memory.

	Copyright (C) 1994, Brian Sawert.
	All rights reserved.

	History:
		02/02/94 - BAS - original code
***********************************************************************/

#include <stdio.h>
#include <stdlib.h>

#include "mcb.h"

	
/* -------------------- defines and macros -------------------- */

/* -------------------- global data -------------------- */

char usage[] = "Usage:  findtsr <TSR name>\n";


/* -------------------- start of code -------------------- */

main(int argc, char *argv[])
{				
	int umb_link, umb_stat, f_umb;		/* upper memory flags */
	unsigned tsr_seg;					/* segment of loaded TSR */
	char tsr_name[NAME_LEN + 1];		/* TSR name */
	int exitval = 1;					/* default to error exit */

	if (argc < 2)
		{								/* no command line args */
		fputs(usage, stderr);			/* print usage message */
		}
	else
		{								/* got argument */
		umb_link = get_umb_link();			/* get upper memory link status */
		umb_stat = set_umb_link(umb_link);	/* set upper memory link */
		f_umb = (umb_stat == 0) ? 1 : 0;

		tsr_seg = get_tsr_seg(argv[1], f_umb);	/* get TSR segment */
	
		if (tsr_seg != 0)
			{							/* found TSR */
			mem_owner_name(tsr_seg - 1, tsr_name);
			printf("%s found at segment %04Xh.\n", tsr_name, tsr_seg);
			exitval = 0;				/* success exit */
			}
		}

	exit(exitval);
}
